package miya.udtf;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.aliyun.odps.udf.ExecutionContext;
import com.aliyun.odps.udf.UDFException;
import com.aliyun.odps.udf.UDTF;
import com.aliyun.odps.udf.annotation.Resolve;
import miya.utils.JsonUtils;

import java.util.ArrayList;

@Resolve({"string->String"})
public class CouponConsumeUdtf extends UDTF {
    @Override
    public void process(Object[] args) throws UDFException {
        try {
            String strJsonArr = (String) args[0];
            JSONArray couponsArr = JsonUtils.str2JsonArr(strJsonArr);
            if (null!=couponsArr && couponsArr.size() >0){
                for (int i = 0; i < couponsArr.size(); i++) {
                    JSONObject couponsObj = couponsArr.getJSONObject(i);
                    JSONArray promGoodsDetailsArr =JsonUtils.jsonObjectGetArr(couponsObj,"promGoodsDetails");
                    if (null!=promGoodsDetailsArr && promGoodsDetailsArr.size() >0){
                        for (int j = 0; j < promGoodsDetailsArr.size(); j++) {
                            JSONObject promGoodsDetailsObj = promGoodsDetailsArr.getJSONObject(j);
                            couponsObj.putAll(promGoodsDetailsObj);
                            forward(couponsObj.toJSONString());
                        }
                    }else{
                        forward(couponsObj.toJSONString());
                    }
                }
            }else{
                forward(null);
            }
        } catch (UDFException e) {
            e.printStackTrace();
            forward(null);
        }


    }



}

//            StringBuffer stringBuffer = new StringBuffer();
//            JSONArray couponsArr = JSON.parseArray(strJsonArr);
//            for (int i = 0; i < couponsArr.size(); i++) {
//                JSONObject couponsObj = couponsArr.getJSONObject(i);
//                JSONArray promGoodsDetailsArr = couponsObj.getJSONArray("promGoodsDetails");
//                JSONObject removeObj = couponsObj.fluentRemove("promGoodsDetails");
//                for (int j = 0; j < promGoodsDetailsArr.size(); j++) {
//                    JSONObject promGoodsDetailsObj = promGoodsDetailsArr.getJSONObject(j);
//                    removeObj.putAll(promGoodsDetailsObj);
//                    stringBuffer.append(removeObj);
//                }
//            }
//            forward(stringBuffer.toString());