package miya.utils;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

/**
 * Created by admin on 2019/5/15.
 */
public class JsonUtils {


    /**
     * JSONObject获取指定key
     *
     * @param json
     * @param key
     * @return
     */
    public static String jsonObjectGetString(JSONObject json, String key) {
        if (null==json) {return null;}
        try {
            //String value = json.getString(key);
            String value = json.get(key).toString();
            return value;
        } catch (Exception e) {
            return null;
        }
    }

    /**
     * JSONObject获取指定JSONObject
     *
     * @param json
     * @param key
     * @return
     */
    public static JSONObject jsonObjectGetObj(JSONObject json, String key) {
        JSONObject obj=null;
        if (null==json) {return obj;}
        try {
            obj=json.getJSONObject(key);
            return obj;
        } catch (Exception e) {
            return obj;
        }
    }

    /**
     * JSONObject获取指定JSONArray
     *
     * @param json
     * @param key
     * @return
     */
    public static JSONArray jsonObjectGetArr(JSONObject json, String key) {
        if (null==json) {return null;}
        try {
            JSONArray jsonArray = json.getJSONArray(key);
            return jsonArray;
        } catch (Exception e) {
            return null;
        }
    }

    /**
     * JSONObject获取指定JSONArray
     *
     * @param strJsonArr
     * @return
     */
    public static JSONArray str2JsonArr(String strJsonArr) {
        try {
            JSONArray jsonArray = JSON.parseArray(strJsonArr);
            return jsonArray;
        } catch (Exception e) {
            return null;
        }
    }

    /**
     * JSONObject合并
     *
     * @param json1
     * @param json2
     */
    public static void jsonUnion(JSONObject json1, JSONObject json2) {
        json1.putAll(json2);
    }


}
