/**
 * Created by admin on 2019/7/16.
 */


import miya.epayment.Tools;
import org.json.JSONObject;
import org.json.XML;

import java.util.concurrent.ConcurrentHashMap;

import static miya.epayment.JsonUtils.jsonObjectGetObj;
import static miya.epayment.JsonUtils.jsonObjectGetString;


public class PayLogUdf2  {
    public static String evaluate(String xmlOrJson, String tradeType, String payType, String tradeStep, String position) {
        try {
            if ("Trade00".equals(tradeStep) && "1.5".equals(tradeType)) {
                JSONObject json = XML.toJSONObject(xmlOrJson);
                JSONObject resJson = null;
                if (!json.has("xml")) {
                    resJson = json;
                } else {
                    resJson = json.getJSONObject("xml");
                }
                double goodsAmt = 0;
                if (resJson.has("data") && resJson.has("request")) {
                    JSONObject request = jsonObjectGetObj(resJson, "request");
                    JSONObject data = jsonObjectGetObj(resJson, "data");
                    String b5 = jsonObjectGetString(data, "B5"); //商品明细信息
                    String a4 = jsonObjectGetString(request, "A4"); //门店 pos 机编号
                    String a5 = jsonObjectGetString(request, "A5"); //门店收银员编号
                    goodsAmt = Tools.getGoodsAmt(b5);
                    ConcurrentHashMap<String, String> conMap = new ConcurrentHashMap<>();
                    conMap.put("8", goodsAmt+"");
                    conMap.put("10", a4);
                    conMap.put("11", a5);
                    return conMap.get(position);
                } else {
                    return null;
                }

            } else if ("Trade00".equals(tradeStep) && "1.0".equals(tradeType)) {
                return dealOldTrade00(xmlOrJson, position);
            } else {
                if ("1.5".equals(tradeType)) {

                    if ("A".equals(payType) || "B".equals(payType)) {
                        return dealTrade03(xmlOrJson,position);
                    } else if ("C".equals(payType) || "D".equals(payType)) {
                        return dealTrade03Refund(xmlOrJson,position);
                    } else if ("E".equals(payType)) {
                        return dealTrade03Revoke(xmlOrJson,position);
                    } else if ("F".equals(payType)) {
                        return dealTrade03Preorder(xmlOrJson,position);
                    } else if ("G".equals(payType)) {
                        return dealTrade03G(xmlOrJson,position);
                    } else {
                        return dealTrade03(xmlOrJson,position);
                    }

                } else if ("1.0".equals(tradeType)) {
                    return dealOldTrade03(xmlOrJson,position);
                } else {
                    return null;
                }
            }


        } catch (Exception e) {
            return null;
        }

    }

    /**
     * 老接口1.0的处理收银员和pos级
     *
     * @param xmlOrJson
     */
    private static String dealOldTrade00(String xmlOrJson, String position) {
        JSONObject json = XML.toJSONObject(xmlOrJson);
        JSONObject resJson = null;
        if (!json.has("xml")) {
            resJson = json;
        } else {
            try {
                resJson = json.getJSONObject("xml").getJSONObject("request");
            } catch (Exception e) {
                resJson = null;
            }
        }

        ConcurrentHashMap<String, String> conMap = new ConcurrentHashMap<>();

        conMap.put("10", jsonObjectGetString(resJson, "userid"));
        conMap.put("11", jsonObjectGetString(resJson, "cashier"));
        return conMap.get(position);
    }


    //A,B
    private static String dealTrade03(String xmlOrJson,String position) {
        JSONObject json = XML.toJSONObject(xmlOrJson);
        JSONObject resJson = null;
        if (!json.has("xml")) {
            resJson = json;
        } else {
            resJson = json.getJSONObject("xml");
        }
//        ConcurrentHashMap<String, String> conMap = new ConcurrentHashMap<>();
        JSONObject valueJSon = new JSONObject();
        System.out.println(" kk,kk");
        valueJSon.put("0", jsonObjectGetString(resJson, "C2"));
        valueJSon.put("1", jsonObjectGetString(resJson, "C3"));
        valueJSon.put("2", jsonObjectGetString(resJson, "C4"));
        valueJSon.put("3", jsonObjectGetString(resJson, "C5"));
        valueJSon.put("4", jsonObjectGetString(resJson, "C6"));
        valueJSon.put("5", jsonObjectGetString(resJson, "C7"));
        valueJSon.put("6", jsonObjectGetString(resJson, "C10"));

        valueJSon.put("9", Tools.getUserid(resJson));
        valueJSon.put("13", jsonObjectGetString(resJson, "C9"));
        valueJSon.put("14", jsonObjectGetString(resJson, "C11"));
        System.out.println(" kk,kk");
        return valueJSon.getString(position);
    }

    //C,D
    private static String dealTrade03Refund(String xmlOrJson  , String position) {
        JSONObject json = XML.toJSONObject(xmlOrJson);
        JSONObject resJson = null;
        if (!json.has("xml")) {
            resJson = json;
        } else {
            resJson = json.getJSONObject("xml");
        }
        ConcurrentHashMap<String, String> conMap = new ConcurrentHashMap<>();

        conMap.put("0", jsonObjectGetString(resJson, "C2"));
        conMap.put("1", jsonObjectGetString(resJson, "C3"));
        conMap.put("2", jsonObjectGetString(resJson, "C4"));
        conMap.put("3", jsonObjectGetString(resJson, "C5"));
        conMap.put("4", jsonObjectGetString(resJson, "C6"));
        conMap.put("5", jsonObjectGetString(resJson, "C8"));
        conMap.put("6", jsonObjectGetString(resJson, "C16"));
        conMap.put("7", jsonObjectGetString(resJson, "C9"));

        conMap.put("12", jsonObjectGetString(resJson, "C7"));
        return conMap.get(position);
    }


    //E
    private static String dealTrade03Revoke(String xmlOrJson ,String position) {
        JSONObject json = XML.toJSONObject(xmlOrJson);
        JSONObject resJson = null;
        if (!json.has("xml")) {
            resJson = json;
        } else {
            resJson = json.getJSONObject("xml");
        }
        ConcurrentHashMap<String, String> conMap = new ConcurrentHashMap<>();

        conMap.put("0", jsonObjectGetString(resJson, "C2"));
        conMap.put("1", jsonObjectGetString(resJson, "C3"));
        conMap.put("2", jsonObjectGetString(resJson, "C4"));
        conMap.put("3", jsonObjectGetString(resJson, "C5"));
        conMap.put("4", jsonObjectGetString(resJson, "C6"));
        conMap.put("5", jsonObjectGetString(resJson, "C10"));

        return conMap.get(position);
    }

    //F
    private static String dealTrade03Preorder(String xmlOrJson,String position) {
        JSONObject json = XML.toJSONObject(xmlOrJson);
        JSONObject resJson = null;
        if (!json.has("xml")) {
            resJson = json;
        } else {
            resJson = json.getJSONObject("xml");
        }
        ConcurrentHashMap<String, String> conMap = new ConcurrentHashMap<>();

        conMap.put("0",  jsonObjectGetString(resJson, "C2"));
        conMap.put("1",  jsonObjectGetString(resJson, "C3"));
        conMap.put("2",  jsonObjectGetString(resJson, "C4"));
        conMap.put("3",  jsonObjectGetString(resJson, "C5"));
        conMap.put("5", jsonObjectGetString(resJson, "C7"));


        return conMap.get(position);
    }

    //G
    private static String dealTrade03G(String xmlOrJson ,String position) {
        JSONObject json = XML.toJSONObject(xmlOrJson);
        JSONObject resJson = null;
        if (!json.has("xml")) {
            resJson = json;
        } else {
            resJson = json.getJSONObject("xml");
        }
        ConcurrentHashMap<String, String> conMap = new ConcurrentHashMap<>();

        conMap.put("0", jsonObjectGetString(resJson, "C2"));
        conMap.put("1", jsonObjectGetString(resJson, "C3"));
        conMap.put("2", jsonObjectGetString(resJson, "C4"));
        conMap.put("3", jsonObjectGetString(resJson, "C5"));
        conMap.put("4", jsonObjectGetString(resJson, "C6"));
        conMap.put("5", jsonObjectGetString(resJson, "C7"));


        return conMap.get(position);
    }





    /**
     * 老接口1.0的处理逻辑
     *
     * @param xmlOrJson
     */
    private static String dealOldTrade03(String xmlOrJson,String position) {
        JSONObject json = XML.toJSONObject(xmlOrJson);
        JSONObject resJson = null;
        if (!json.has("xml")) {
            resJson = json;
        } else {
            resJson = json.getJSONObject("xml");
        }
        ConcurrentHashMap<String, String> conMap = new ConcurrentHashMap<>();

        conMap.put("0", jsonObjectGetString(resJson, "trad_status"));
        conMap.put("1", jsonObjectGetString(resJson, "error_code"));
        conMap.put("2", jsonObjectGetString(resJson, "error_msg"));
        conMap.put("3", jsonObjectGetString(resJson, "out_trade_no"));
        conMap.put("4", jsonObjectGetString(resJson, "trade_no"));
        conMap.put("5", jsonObjectGetString(resJson, "total_fee", "oldtotalfee"));

        conMap.put("6", jsonObjectGetString(resJson, "fundbilllist"));
        conMap.put("7", jsonObjectGetString(resJson, "refund_amount"));
        conMap.put("9", jsonObjectGetString(resJson, "buyer_user_id"));
        conMap.put("12",  jsonObjectGetString(resJson, "out_refund_req_no"));


        return conMap.get(position);

    }



    

}

